Global Success As Integer
Global Transtype As Integer

Global Const FTP_DATABUFFER = 4096 'guter Wert fr X25/Ethernet/Token Ring
'-----------------------------------------------------------

'Transferart
Global Const TYPE_A = "A"    'ASCII
Global Const TYPE_I = "I"    'BINARY
'
'-----------------------------------------------------------
'              Rckgabewerte der FTP-Befehle
'-----------------------------------------------------------
Global Const FTPERR_OK = 0
Global Const FTPERR_ENTERPASSWORD = 1
Global Const FTPERR_ACCOUNTNEEDED = 2
Global Const FTPERR_CANCELBYUSER = -1
Global Const FTPERR_INVALIDPARAMETER = 1000
Global Const FTPERR_SESSIONUSED = 1001
Global Const FTPERR_NOTINITIALIZED = 1002
Global Const FTPERR_NOTCONNECTED = 1003
Global Const FTPERR_CANTOPENFILE = 1004
Global Const FTPERR_CANTWRITE = 1005
Global Const FTPERR_NOACTIVESESSION = 1006
Global Const FTPERR_STILLCONNECTED = 1007
Global Const FTPERR_SERVERCANTEXECUTE = 1008
Global Const FTPERR_LOGINREFUSED = 1009
Global Const FTPERR_NOREMOTEFILE = 1010
Global Const FTPERR_TRANSFERREFUSED = 1011
Global Const FTPERR_WINSOCKNOTUSABLE = 1012
Global Const FTPERR_CANTCLOSE = 1013
Global Const FTPERR_UNKNOWNHOST = 2001
Global Const FTPERR_NOREPLY = 2002
Global Const FTPERR_CANTCONNECT = 2003
Global Const FTPERR_CONNECTREJECTED = 2004
Global Const FTPERR_SENDREFUSED = 2005
Global Const FTPERR_DATACONNECTION = 2006
Global Const FTPERR_TIMEOUT = 2007
Global Const FTPERR_UNEXPECTEDANSWER = 3001
Global Const FTPERR_CANNOTCHANGETYPE = 3002
Global Const FTPERR_CANTCREATEWINDOW = 5002
Global Const FTPERR_INSMEMORY = 5003
Global Const FTPERR_CANTCREATESOCKET = 5004
Global Const FTPERR_CANTBINDSOCKET = 5005


Declare Function FtpInit Lib "FTP4W.DLL" (ByVal HWND As Integer) As Integer
Declare Function FtpRelease Lib "FTP4W.DLL" () As Integer
'Verbindung
Declare Function FtpLogin Lib "FTP4W.DLL" (ByVal Host As String, ByVal User As String, ByVal Password As String, ByVal HWND As Integer, ByVal msge As Integer) As Integer
Declare Function FtpOpenConnection Lib "FTP4W.DLL" (ByVal Host As String) As Integer
Declare Function FtpCloseConnection Lib "FTP4W.DLL" () As Integer
Declare Function FtpLocalClose Lib "FTP4W.DLL" () As Integer
'Identifikation
Declare Function FtpSendUserName Lib "FTP4W.DLL" (ByVal UserName As String) As Integer
Declare Function FtpSendPasswd Lib "FTP4W.DLL" (ByVal Passwd As String) As Integer
'FTP-Befehle
Declare Function FtpHelp Lib "FTP4W.DLL" (ByVal Arg As String, ByVal Buf As String, ByVal BufSize As Integer) As Integer
Declare Function FtpCWD Lib "FTP4W.DLL" (ByVal Path As String) As Integer
Declare Function FtpQuote Lib "FTP4W.DLL" (ByVal Cmd As String, ByVal ReplyBuf As String, ByVal BufSize As Integer) As Integer
Declare Function FtpSetType Lib "FTP4W.DLL" (ByVal Typ As Integer) As Integer  '
'Dateitransfer
Declare Function FtpAbort Lib "FTP4W.DLL" () As Integer
Declare Function FtpSendFile Lib "FTP4W.DLL" (ByVal Lcl As String, ByVal Remote As String, ByVal Typ As Integer, ByVal Notify As Integer, ByVal HWND As Integer, ByVal msge As Integer) As Integer
Declare Function FtpRecvFile Lib "FTP4W.DLL" (ByVal Remote As String, ByVal Lcl As String, ByVal Typ As Integer, ByVal Notify As Integer, ByVal HWND As Integer, ByVal msge As Integer) As Integer
'Abfrage
Declare Function FtpGetFileSize Lib "FTP4W.DLL" () As Long
'Verzeichnis
Declare Function FtpDir Lib "FTP4W.DLL" (ByVal Def As String, ByVal LocalFile As String, ByVal LongDir As Integer, ByVal HWND As Integer, ByVal msge As Integer) As Integer
'Sonstiges
Declare Function FtpBytesTransfered Lib "FTP4W.DLL" () As Long
Declare Function FtpBytesToBeTransfered Lib "FTP4W.DLL" () As Long
Declare Sub FtpSetDefaultTimeOut Lib "FTP4W.DLL" (ByVal nTo_in_sec As Integer)
Declare Sub FtpSetDefaultPort Lib "FTP4W.DLL" (ByVal nDefPort As Integer)
Declare Sub FtpSetAsynchronousMode Lib "FTP4W.DLL" ()
Declare Sub FtpSetSynchronousMode Lib "FTP4W.DLL" ()
Declare Function FtpIsAsynchronousMode Lib "FTP4W.DLL" () As Integer
Declare Sub FtpSetNewDelay Lib "FTP4W.DLL" (ByVal X As Integer)
Declare Sub FtpSetNewSlices Lib "FTP4W.DLL" (ByVal X As Integer, ByVal Y As Integer)
'Utilities
Declare Function WEP Lib "FTP4W.DLL" (ByVal nType As Integer) As Integer
Declare Function FtpSetVerboseMode Lib "FTP4W.DLL" (ByVal bVerBoseMode As Integer, ByVal HWND As Integer, ByVal wMsg As Integer) As Integer

Function FTP4W_Error (ErrorValue As Integer) As String
  Dim Msg$
  '
  Select Case ErrorValue
   Case FTPERR_ENTERPASSWORD
     Msg$ = "Passwort fr Usernamen erforderlich"
   Case FTPERR_ACCOUNTNEEDED
     Msg$ = "Kein Zugang fr diese Kennung"
   Case FTPERR_CANCELBYUSER
     Msg$ = "Userabbruch"
   Case FTPERR_INVALIDPARAMETER
     Msg$ = "falsche Parameter"
   Case FTPERR_SESSIONUSED
     Msg$ = "User hat schon Connect"
   Case FTPERR_NOTINITIALIZED
     Msg$ = "FTP Inizialisierungsfehler"
   Case FTPERR_NOTCONNECTED
     Msg$ = "Kein Connect vorhanden"
   Case FTPERR_CANTOPENFILE
     Msg$ = "Datei nicht gefunden"
   Case FTPERR_CANTWRITE
     Msg$ = "Fehler beim Schreiben"
   Case FTPERR_NOACTIVESESSION
     Msg$ = "FTP Inizialisierung nicht erfolgt"
   Case FTPERR_STILLCONNECTED
     Msg$ = "FTP Connect noch nicht geschlossen"
   Case FTPERR_SERVERCANTEXECUTE
     Msg$ = "Dateiaktion kann nicht gestartet werden"
   Case FTPERR_LOGINREFUSED
     Msg$ = "Username u/o Passwort falsch"
   Case FTPERR_NOREMOTEFILE
     Msg$ = "Datei kann nicht geffnet werden"
   Case FTPERR_TRANSFERREFUSED
     Msg$ = "Transfer verweigert"
   Case FTPERR_WINSOCKNOTUSABLE
     Msg$ = "Winsock.dll zu alt"
   Case FTPERR_UNKNOWNHOST
     Msg$ = "Hostadresse nicht auflsbar"
   Case FTPERR_NOREPLY
     Msg$ = "Antwort kann nicht gesendet werden"
   Case FTPERR_CANTCONNECT
     Msg$ = "Fehler whrend der Verbindung"
   Case FTPERR_CONNECTREJECTED
     Msg$ = "Kein FTP Server"
   Case FTPERR_SENDREFUSED
     Msg$ = "Daten konnten nicht gesendet werden"
   Case FTPERR_DATACONNECTION
     Msg$ = "Verbindungsfehler (DATA-PORT)"
   Case FTPERR_TIMEOUT
     Msg$ = "Zeitberschreitung"
   Case FTPERR_UNEXPECTEDANSWER
     Msg$ = "Nicht erwartete Antwort"
   Case FTPERR_CANNOTCHANGETYPE
     Msg$ = "Befehl abgelehnt"
   Case FTPERR_CANTCREATEWINDOW
     Msg$ = "Zu wenig freie Resourcen"
   Case FTPERR_INSMEMORY
     Msg$ = "Zu wenig Stapelspeicher"
   Case FTPERR_CANTCREATESOCKET
     Msg$ = "SOCKETFEHLER"
   Case FTPERR_CANTBINDSOCKET
     Msg$ = "Verbindung nicht erfolgreich"
  End Select
  '
  FTP4W_Error = Msg$
  '
End Function

